/*
 * lcd_eeprom.c
 *
 * Created: 2016. 09. 07. 9:16:29
 * Author : AradiSzilard
 */ 

/******************************************************************************
* Include files
******************************************************************************/
#include <avr/io.h>
#include <inttypes.h>
#include <avr/interrupt.h>
#include <stdio.h>

#include "lcd.h"
#include "eeprom.h"

/******************************************************************************
* Macros
******************************************************************************/
#define OK 0
#define BAD_ADDR 1
#define TRUE 1
#define FALSE 0
/******************************************************************************
* Constants
******************************************************************************/


/******************************************************************************
* Global Variables
******************************************************************************/

uint8_t timer_5ms=FALSE,timer_10ms=FALSE,timer_25ms=FALSE,timer_100ms=FALSE,timer_1000ms=FALSE;
uint16_t ido=0;
uint8_t szamlalo=0;

char write_string[100]={};

/******************************************************************************
* External Variables
******************************************************************************/


/******************************************************************************
* Local Function Declarations
******************************************************************************/


/******************************************************************************
* Local Function Definitions
******************************************************************************/

/******************************************************************************
* Function:         void timer_init(void)
* Description:		Timer inicializlsa
* Input:
* Output:
* Notes:
******************************************************************************/
void timer_init(void)
{
	TCCR0A=0b00001011;
	OCR0A=125;
	TIMSK0=0b00000010;
}


int main(void)
{
	lcdinit();
	EEPROM_read(100,&szamlalo);
	timer_init();
	sei();
	
	
	while(1)
	{

		if(timer_5ms)
		{
			
			timer_5ms=FALSE;
		}
		
		if(timer_10ms)
		{
			timer_10ms=FALSE;
		}
		
		if(timer_25ms)
		{
			timer_25ms=FALSE;
		}
		
		if(timer_100ms)
		{
			
			
			if (OK==EEPROM_read(100,&szamlalo))
			{
				sprintf(write_string,"%d   ",szamlalo);
				lcdreir(write_string);
				lcd_rethome();
			}
			else
			{
				lcdreir("Hibas cim!");
				lcd_rethome();
			}
			
			timer_100ms=FALSE;
		}
		
		if(timer_1000ms)
		{
			szamlalo++;
			if(BAD_ADDR==EEPROM_write(100,szamlalo))
			{
				lcdreir("Hibas cim!");
				lcd_rethome();
			}
			timer_1000ms=FALSE;
		}
		
	}
}

/******************************************************************************
* Interrupt Routines
******************************************************************************/

/******************************************************************************
* Function:			ISR(TIMER0_COMP_vect)
* Description:		Timer0 Output Compare megszakts
* Input:
* Output:
* Notes:
******************************************************************************/
ISR(TIMER0_COMP_vect)
{
	if(!(ido % 5))
	{
		timer_5ms=TRUE;
	}
	if(!(ido % 10))
	{
		timer_10ms=TRUE;
	}
	if(!(ido % 25))
	{
		timer_25ms=TRUE;
	}
	if(!(ido % 100))
	{
		timer_100ms=TRUE;
	}
	if(!(ido % 1000))
	{
		timer_1000ms=TRUE;
	}

	ido++;
}